﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;


namespace Airbus
{
    public partial class FormAirplane : Form
    {
        private DrawningAirplane airplane;

        public FormAirplane()
        {
            InitializeComponent();
        }

        private void Draw()
        {
            Bitmap bmp = new(pictureBox.Width, pictureBox.Height);
            Graphics g = Graphics.FromImage(bmp);
            airplane.DrawTransport(g);
            pictureBox.Image = bmp;
        }
        private void SetData()
        {
            Random random = new Random();
            airplane.SetPosition(random.Next(10, 100), random.Next(10, 100), pictureBox.Width, pictureBox.Height);
            toolStripStatusLabelSpeed.Text = $"Скорость: {airplane.airplane?.Speed}";
            toolStripStatusLabelWight.Text = $"Вес: {airplane.airplane?.Weight}";
            toolStripStatusLabelColor.Text = $" : {airplane.airplane?.BodyColor}";
            airplane.Upd_count_Porthole(count_porthole);
        }
        private void buttonCreate_Click(object sender, EventArgs e)
        {
            Random random = new Random();
            airplane = new DrawningAirplane(random.Next(100, 300), random.Next(1000, 3000), Color.FromArgb(random.Next(0, 256), random.Next(0, 256), random.Next(0, 256)));

            SetData();
            Draw();
        }

        private void ButtonMove_Click(object sender, EventArgs e)
        {
            string name = ((Button)sender)?.Name ?? string.Empty;
            switch (name)
            {
                case "buttonLeft":
                    Console.WriteLine("");
                    airplane?.MoveTransport(Direction.Left);
                    break;
                case "buttonUp":
                    airplane?.MoveTransport(Direction.Up);
                    break;
                case "buttonRight":
                    airplane?.MoveTransport(Direction.Right);
                    break;
                case "buttonDown":
                    airplane?.MoveTransport(Direction.Down);
                    break;
            }
            Draw();
        }
        CountPorthole count_porthole = CountPorthole.Ten;
        private void comboBoxPortholeSer_SelectedIndexChanged(object sender, EventArgs e)
        {


            switch (comboBoxPortholeSer.Text)
            {
                case "10":
                    count_porthole = CountPorthole.Ten;
                    toolStripStatusLabelSpeed.Text = Convert.ToString((int)count_porthole);
                    break;
                case "20":
                    count_porthole = CountPorthole.Twenty;
                    break;
                case "30":
                    count_porthole = CountPorthole.Thirty;
                    break;

            }
            if (airplane != null)
            {
                airplane.Upd_count_Porthole(count_porthole);
                Draw();
            }
        }
        private void PictureBox_Resize(object sender, EventArgs e)
        {
            airplane?.ChangeBorders(pictureBox.Width, pictureBox.Height);
            Draw();
        }
        private void buttonModCreate_Click(object sender, EventArgs e)
        {
            Random random = new Random();
            airplane = new DrawingAirbus(random.Next(100, 300), random.Next(1000, 3000),
                Color.FromArgb(random.Next(0, 256), random.Next(0, 256), random.Next(0, 256)),
                Color.FromArgb(random.Next(0, 256), random.Next(0, 256), random.Next(0, 256)),
                true, true);
            SetData();
            Draw();
        }
    }
}
